% Shrutilipi Bhattacharjee
% Basic Semantic Kriging (OK) with Motivating Example
% 20190505
% Input parameters: 
% GeoTiff of Primary Parameter (with missing value as NaN)
% Constraints: 
% Maximum and minimum number of interpolating points = 35 and 2

clear all;
close all;

% Input the raster with missing values as NaN
[PrimaryParameter, R1] = geotiffread('MotivatingExample_XCO2'); 

% Determine the number of rows and columns in the raster
[Row,Col] = size(PrimaryParameter);

% Input the maximum number of interpolating points
InterpolatingPoints = 10; % Default number of maximum interpolating points

% Change the maximum number of interpolating points
prompt = 'Please enter the maximum number of interpolating ponits:::';
InterpolatingPoints = input(prompt);

% Calculate the prediction zone, its size parameters
Max = Row;
Corner = (Row+1)/2;
for i = 1:Row
    for j = 1:Col
        if isnan(PrimaryParameter(i,j))
            fprintf('Prediction location is (%d, %d)',[i,j]);
                         
            %Creation of prediction zone: PredictionZone
            PredictionZoneParameter = NaN(Max,Max);
            Flag = zeros(Max,Max);
            Counter = 0;
            Max_temp = 1;
            Corner_temp = 0;
            Mid = (Max+1)/2;
            while Max_temp <= Max && Corner_temp <= Corner
                for m=(-1*Corner_temp):1:(1*Corner_temp)
                    for n=(-1*Corner_temp):1:(1*Corner_temp)
                        if Counter<=InterpolatingPoints && (i+m)>0 && (j+n)>0 && (i+m)<=Row && (j+n)<=Col && Flag(Mid+m,Mid+n)==0
                            PredictionZoneParameter(Mid+m,Mid+n) = PrimaryParameter((i+m),(j+n));
                          	Flag(Mid+m,Mid+n) = 1;
                            Counter = Counter + 1;
                       	end
                        if m == 0 && n == 0
                            PredictionZoneParameter(Mid+m,Mid+n) = 1000000;
                        end
                    end  
               	end
                Max_temp = Max_temp + 2;
                Corner_temp = Corner_temp + 1;
            end
                      
            PredictionZoneParameter( ~any(PredictionZoneParameter,2), : ) = []; 
            PredictionZoneParameter( :, ~any(PredictionZoneParameter,1) ) = [];
            
            % Flag the prediction point in the prediction zone
            % Determine the Z(xi): ValInterpolatingPoints
            PredLocRow = 0;
            PredLocCol = 0;
            ValInterpolatingPoints = NaN(Max*Max,1);
            Counter = 0;
            
            for m = 1:1:size(PredictionZoneParameter,1)
                for n = 1:1:size(PredictionZoneParameter,2)
                	if PredictionZoneParameter(m,n) == 1000000
                        PredLocRow = m;
                        PredLocCol = n;
                        PredictionZoneParameter(m,n) = NaN;
                    end
                    ValInterpolatingPoints(Counter+1,1) = PredictionZoneParameter(m,n);
                    Counter = Counter +1;
                end
            end
                   
            ValInterpolatingPoints(ValInterpolatingPoints == 0) = [];
            ValInterpolatingPoints = ValInterpolatingPoints(~isnan(ValInterpolatingPoints));
            NonNaN = nnz(~isnan(PredictionZoneParameter));
            
            % Determine the pairwise Euclidean distance matrices: SemivarianceDist(NxN), DistanceDist(Nx1)
            % Determine the pairwise temporary semivariance matrix: Semivariance_Prev(NxN)
            SemivarianceDist = NaN(size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1),size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1));  
            DistanceDist = zeros(size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1),size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1));  
            Semivariance_Prev = NaN(size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1),size(PredictionZoneParameter,2)*size(PredictionZoneParameter,1));      
            for p = 1:1:size(PredictionZoneParameter,1)
                for q = 1:1:size(PredictionZoneParameter,2)
                    for m = 1:1:size(PredictionZoneParameter,1)
                        for n = 1:1:size(PredictionZoneParameter,2)
                            if ~isnan(PredictionZoneParameter(p,q)) && ~isnan(PredictionZoneParameter(m,n)) 
                                SemivarianceDist((p-1)*size(PredictionZoneParameter,2)+q,(m-1)*size(PredictionZoneParameter,2)+n) = sqrt((p-m)^2+(q-n)^2);
                                Semivariance_Prev((p-1)*size(PredictionZoneParameter,2)+q,(m-1)*size(PredictionZoneParameter,2)+n) = (PredictionZoneParameter(p,q) - PredictionZoneParameter(m,n)).^2;
                            elseif p==PredLocRow && q==PredLocCol && ~isnan(PredictionZoneParameter(m,n))
                                DistanceDist((p-1)*size(PredictionZoneParameter,2)+q,(m-1)*size(PredictionZoneParameter,2)+n) = sqrt((p-m)^2+(q-n)^2);
                            elseif ~isnan(PredictionZoneParameter(p,q)) && m==PredLocRow && n==PredLocCol  
                                DistanceDist((p-1)*size(PredictionZoneParameter,2)+q,(m-1)*size(PredictionZoneParameter,2)+n) = sqrt((p-m)^2+(q-n)^2);
                            else 
                                DistanceDist((p-1)*size(PredictionZoneParameter,2)+q,(m-1)*size(PredictionZoneParameter,2)+n) = 0;
                            end
                        end
                    end
                end    
            end
            
            Semivariance_Prev(~any(Semivariance_Prev,2),:) = []; 
            Semivariance_Prev(:,~any(Semivariance_Prev,1)) = [];
            Semivariance_Prev = Semivariance_Prev(all(~isnan(Semivariance_Prev),2),:); 
            Semivariance_Prev = Semivariance_Prev(:,all(~isnan(Semivariance_Prev)));

            SemivarianceDist(~any(SemivarianceDist,2),:) = []; 
            SemivarianceDist(:,~any(SemivarianceDist,1)) = [];
            SemivarianceDist = SemivarianceDist(all(~isnan(SemivarianceDist),2),:); 
            SemivarianceDist = SemivarianceDist(:,all(~isnan(SemivarianceDist)));
            
            DistanceDist = DistanceDist(:,((PredLocRow-1)*size(PredictionZoneParameter,2)+PredLocCol));
            DistanceDist = DistanceDist(DistanceDist~= 0);
            
            % Determine the pairwise semivariance matrix: Semivariance(NxN)
            Semivariance = NaN;
            
            % Determine the average semivariance score at every unique distance
            Count = zeros(size(unique(SemivarianceDist),1),1);
            SumSemivariance = zeros(size(unique(SemivarianceDist),1),1);
            UniqueDist = unique(SemivarianceDist);
            Counter = 1;
            while Counter <= size(UniqueDist,1)
                for p = 1:1:size(Semivariance_Prev,2)
                    for q = 1:1:size(Semivariance_Prev,1)
                        if SemivarianceDist(p,q) == UniqueDist(Counter,1)
                            Count(Counter) = Count(Counter)+1;
                            SumSemivariance(Counter) = SumSemivariance(Counter) + Semivariance_Prev(p,q);                   
                        end
                  	end
                end
                Counter = Counter + 1;
            end                            
            
            % Assign the average semivariance score to every unique distance
            for p = 1:1:size(SemivarianceDist)
                for q = 1:1:size(SemivarianceDist)
                    Counter = 1;
                    while Counter <= size(UniqueDist,1)
                        if SemivarianceDist(p,q) == UniqueDist(Counter,1)
                            Semivariance(p,q) = SumSemivariance(Counter)/(2*Count(Counter));
                        end
                        Counter = Counter + 1;
                    end
                end
            end
            
            %Plot the experimental semivariogram
           	scatter(SemivarianceDist(:),Semivariance(:),'filled')
            ft=fittype('exp1');
            ExpSemivariogram=fit(SemivarianceDist(:),Semivariance(:),ft);
            ExpSemivariogram;
            hold on
            plot(ExpSemivariogram);
            hold off
            xlabel('Distance (h)');
            ylabel('Semivariance (\gamma)');
            title('Experimental semivariogram (Exponential model)');
            Sill = feval(ExpSemivariogram, max(SemivarianceDist(:)));
            Nugget = feval(ExpSemivariogram, 0);
            PartialSill = Sill - Nugget;
            
            % Determine the covariance matrix (C): Covariance(NxN) with
            % Exponential model
            Covariance = NaN;
            for p = 1:1:size(SemivarianceDist,2)
                for q = 1:1:size(SemivarianceDist,1)
                    if SemivarianceDist(p,q) == 0
                        Covariance(p,q) = 0;
                    else
                        Covariance(p,q) = Sill - Nugget * (1 - exp(-SemivarianceDist(p,q)/(max(SemivarianceDist(:))/3)));
                    end
                end
            end
            
            % Determine the distance matrix (D): Distance(Nx1)
            Distance = NaN;
            for p = 1:1:size(DistanceDist)
                Distance(p,1) = Sill - Nugget * (1 - exp(-DistanceDist(p)/(max(SemivarianceDist(:))/3)));
            end
            
            % Determine the weight vector of OK: W_OK(Nx1)
            PrevW_OK = NaN;
            W_OK = NaN;
            PrevW_OK = Covariance\Distance;
            for p = 1:1:size(PrevW_OK,1)
                W_OK(p,1)=(PrevW_OK(p)-min(PrevW_OK))/(max(PrevW_OK)-min(PrevW_OK))* (3-1)+1;
            end
            W_OK = normalize(W_OK,'norm',1);
            
            % Calculate the missing value: PrimaryParameter(i,j)
            PrimaryParameter(i,j) = dot(W_OK,ValInterpolatingPoints);
            fprintf(' and the predicted value is: %d \n', PrimaryParameter(i,j));
        end
    end
end